import { world, system } from "@minecraft/server";
import {
  ActionFormData,
  MessageFormData,
  ModalFormData
} from "@minecraft/server-ui";
world.afterEvents.playerSpawn.subscribe(event => {
  event.player.runCommandAsync('setblock 8 23 62 redstone_block')
})

system.afterEvents.scriptEventReceive.subscribe(event => {
  if(event.id == "loli:target") 
  {
    event.sourceEntity.runCommandAsync(`playsound random.levelup @a ~ ~ ~ 1 2`);
    event.sourceEntity.runCommandAsync(`summon loli:target2 -8 37 38`);
    event.sourceEntity.runCommandAsync(`summon loli:target2 44 25 39`);
    event.sourceEntity.runCommandAsync(`summon loli:target2 46 16 89`);
  }
  if(event.id =="loli:saigo")
  {
      let form = new ActionFormData();
          form.title("What should I do...?");
          form.body("There are only 3 actions I can think of right now...");
          form.button("Run to city", "textures/items/apple");
          form.button("Fight The Man", "textures/items/apple");
          form.button("Follow The Man", "textures/items/apple");
          form.show(event.sourceEntity).then(form => {
            if (form.canceled) return event.sourceEntity.runCommandAsync(`scriptevent loli:saigo`);
            if(form.selection == 2)
            {
              event.sourceEntity.runCommandAsync(`setblock 32 25 24 redstone_block`);
            }
            if(form.selection == 1)
            {
              event.sourceEntity.runCommandAsync(`setblock 36 25 32 redstone_block`);
            }
            if(form.selection == 0)
            {
              event.sourceEntity.runCommandAsync(`setblock 36 25 35 redstone_block`);
            }
          }).catch((e) => {
            console.error(e, e.stack);
          });
  }
})
system.runInterval( function(){
  const players = [...world.getPlayers()]
  const player = players[0];
  player.runCommandAsync(`execute as @e[type=!player] at @s if block ~ ~ ~ lava run kill @s`);
  player.runCommandAsync(`execute as @a at @s if block ~ ~-2 ~ beacon run setblock 19 25 17 redstone_block`);
  player.runCommandAsync(`execute as @a at @s if block ~ ~-3 ~ beacon run setblock 19 25 17 redstone_block`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 2 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 29`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 30`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 30`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 30`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 30`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 3 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 1 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 31`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 3 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 1 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 32`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 3 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 1 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 33`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 6 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 3 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 1 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 34`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 5 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 4 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 3 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 1 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle 0 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -1 37 35`);
    player.runCommandAsync(`execute as @s[tag=snowed] run particle minecraft:falling_dust_top_snow_particle -2 37 35`);
} , 1)
world.beforeEvents.itemUse.subscribe(event => {
  if(event.itemStack.typeId == "minecraft:potato") {
    event.source.runCommandAsync(`setblock 26 25 27 redstone_block`);
  }
  if(event.itemStack.typeId == "minecraft:carrot") {
    event.source.runCommandAsync(`execute as @e[type=!player,type=!leash_knot,type=!boat,type=!item,type=!arrow,tag=no,type=!npc,tag=syu,type=!loli:target,type=!loli:target2] at @s run tp @p`);
  }
})
world.afterEvents.itemUseOn.subscribe(event => {
  const block = event.source.dimension.getBlock(event.block.location);
  if (block.typeId == "minecraft:noteblock" && !event.source.hasTag('z')&& !event.source.hasTag('x')&& !event.source.hasTag('c')&& !event.source.hasTag('v')&& !event.source.hasTag('b')) {
    let form = new ModalFormData()
    form.title("PIN input device");
    form.textField("Enter PIN", "2 digit number")
    
    form.show(event.source).then(r => {
      if(r.canceled) return;
       if (r.formValues[0] == "10")
       {
        event.source.runCommandAsync(`setblock 2 30 28 stone`);
        event.source.runCommandAsync(`structure load mystructure:toilet -2 31 29`);
        event.source.runCommandAsync(`tag @s add z`);
        event.source.runCommandAsync(`setblock 6 33 35 stone`);
        event.source.runCommandAsync(`tellraw @a {"rawtext":[{"text":"[Saki] The snow is melting...?"}]}`);
        event.source.runCommandAsync(`setblock 2 31 28 air`);
        event.source.runCommandAsync(`playsound random.levelup @a ~ ~ ~ 1 2`);
        event.source.runCommandAsync(`tag @a remove snowed`);
        event.source.runCommandAsync(`scoreboard players set @a snow -10000`);
  
      } else event.source.runCommandAsync(`tellraw @s {"rawtext":[{"text":"[Saki] Hmm...? Nothing happened..."}]}`);
    }).catch(e => {
      console.error(e, e.stack);
    });
  }
  if (block.typeId == "minecraft:noteblock" && event.source.hasTag('z')&& !event.source.hasTag('x')&& !event.source.hasTag('c')&& !event.source.hasTag('v')&& !event.source.hasTag('b')) {
    let form = new ModalFormData()
    form.title("PIN input device");
    form.textField("Enter PIN", "1 word")
    
    form.show(event.source).then(r => {
      if(r.canceled) return;
       if (r.formValues[0] == "Shall" || r.formValues[0] == "shall")
       {
        event.source.runCommandAsync(`setblock -24 32 16 stone`);
        event.source.runCommandAsync(`tag @s remove z`);
        event.source.runCommandAsync(`tag @s add x`);
        event.source.runCommandAsync(`tellraw @a {"rawtext":[{"text":"[Saki] I think I heard a sound somewhere..."}]}`);
        event.source.runCommandAsync(`setblock -12 35 12 redstone_torch`);
        event.source.runCommandAsync(`setblock -11 35 12 redstone_torch`);
        event.source.runCommandAsync(`playsound random.levelup @a ~ ~ ~ 1 2`);
  
      } else event.source.runCommandAsync(`tellraw @s {"rawtext":[{"text":"[Saki] Nothing happen..."}]}`);
    }).catch(e => {
      console.error(e, e.stack);
    });
  }
  if (block.typeId == "minecraft:noteblock" && !event.source.hasTag('z')&& event.source.hasTag('x')&& !event.source.hasTag('c')&& !event.source.hasTag('v')&& !event.source.hasTag('b')) {
    let form = new ModalFormData()
    form.title("PIN input device");
    form.textField("Enter PIN", "4 digit number")
    
    form.show(event.source).then(r => {
      if(r.canceled) return;
       if (r.formValues[0] == "2701")
       {
        event.source.runCommandAsync(`setblock -28 31 12 stone`);
        event.source.runCommandAsync(`setblock -27 29 12 redstone_torch`);
        event.source.runCommandAsync(`tag @s remove x`);
        event.source.runCommandAsync(`tag @s add c`);
        event.source.runCommandAsync(`tellraw @a {"rawtext":[{"text":"[Saki] Door has opened!"}]}`);
        event.source.runCommandAsync(`structure load mystructure:test2 ~ ~ ~`);
        event.source.runCommandAsync(`playsound random.levelup @a ~ ~ ~ 1 2`);
  
      } else event.source.runCommandAsync(`tellraw @s {"rawtext":[{"text":"[Saki] Hmm... I enterd wrong number...?"}]}`);
    }).catch(e => {
      console.error(e, e.stack);
    });
  }
})